# coding: utf-8

"""
    ARLAS Exploration API

    Explore the content of ARLAS collections

    OpenAPI spec version: 11.0.3
    Contact: contact@gisaia.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class AggregatedGeometry(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'strategy': 'str',
        'field': 'str'
    }

    attribute_map = {
        'strategy': 'strategy',
        'field': 'field'
    }

    def __init__(self, strategy=None, field=None):
        """
        AggregatedGeometry - a model defined in Swagger
        """

        self._strategy = None
        self._field = None

        if strategy is not None:
          self.strategy = strategy
        if field is not None:
          self.field = field

    @property
    def strategy(self):
        """
        Gets the strategy of this AggregatedGeometry.

        :return: The strategy of this AggregatedGeometry.
        :rtype: str
        """
        return self._strategy

    @strategy.setter
    def strategy(self, strategy):
        """
        Sets the strategy of this AggregatedGeometry.

        :param strategy: The strategy of this AggregatedGeometry.
        :type: str
        """
        allowed_values = ["bbox", "centroid", "geohash", "first", "last", "byDefault"]
        if strategy not in allowed_values:
            raise ValueError(
                "Invalid value for `strategy` ({0}), must be one of {1}"
                .format(strategy, allowed_values)
            )

        self._strategy = strategy

    @property
    def field(self):
        """
        Gets the field of this AggregatedGeometry.

        :return: The field of this AggregatedGeometry.
        :rtype: str
        """
        return self._field

    @field.setter
    def field(self, field):
        """
        Sets the field of this AggregatedGeometry.

        :param field: The field of this AggregatedGeometry.
        :type: str
        """

        self._field = field

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, AggregatedGeometry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
